﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Infragistics.WebUI.UltraWebGrid.DocumentExport;
using Infragistics.Documents.Report.Text;
using Infragistics.Documents.Report;
using Infragistics.Documents.Graphics;
using System.Data;

public partial class _Default : System.Web.UI.Page 
{
    UltraWebGridSample ds = new UltraWebGridSample();

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            UltraWebGrid1.DataSource = ds;
            UltraWebGrid1.DataBind();        
        }
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        this.UltraWebGridDocumentExporter1.ExportMode =
            Infragistics.WebUI.UltraWebGrid.Exporter.ExportMode.InBrowser;
       
        this.UltraWebGridDocumentExporter1.Export(this.UltraWebGrid1);
    }

    protected void UltraWebGridDocumentExporter1_CellExporting(object sender, CellExportingEventArgs e)
    {
       // Add the extra text to the cell
       // In this case we're adding a pink heart character
       IText text = e.ReportCell.AddText();

       // Add the extra text to the cell
       // In this case we're adding a pink heart character
       //Color oColor = new Color(System.Drawing.Color.Red);
       SolidColorBrush pinkBrush =
           new SolidColorBrush(new Color(System.Drawing.Color.Blue));
       text.AddContent((char)9829, new Infragistics.Documents.Report.Text.Style(text.Style.Font, pinkBrush));

       // Add the text that will be exported for the cell
       // The exporter will add another text object to export the cell's
       // text so the cell's text will be on the next line if we don't do this.
       SolidColorBrush blackBrush =
           new SolidColorBrush(new Color(System.Drawing.Color.Red));

       Infragistics.Documents.Report.Text.Style textStyle = 
           new Infragistics.Documents.Report.Text.Style(new  Font("Verdana", 12), blackBrush);

        // Check for column index to align zipcode to horizontal right in PDF
       if (e.GridCell.Column.Index == 4)
       {
           text.Alignment.Horizontal = Infragistics.Documents.Report.Alignment.Right;
       }

        //text.AddContent(" " + e.ExportValue.ToString(), textStyle);
       text.AddContent(string.Format(" {0}", e.ExportValue.ToString()), textStyle);
       // Cancel the event so the cell's text isn't exported again.
       e.Cancel = true;
    }

    protected void UltraWebGridDocumentExporter1_HeaderCellExporting(object sender, MarginCellExportingEventArgs e)
    {        
        IText text = e.ReportCell.AddText();

        SolidColorBrush pinkBrush =
            new SolidColorBrush(new Color(System.Drawing.Color.Blue));
        text.AddContent((char)9829, new Infragistics.Documents.Report.Text.Style(text.Style.Font, pinkBrush));

        // Add the text that will be exported for the Header text
        // The exporter will add another text object to export the Header's text
        SolidColorBrush blackBrush =
            new SolidColorBrush(new Color(System.Drawing.Color.DarkOrange));

        Infragistics.Documents.Report.Text.Style textStyle =
            new Infragistics.Documents.Report.Text.Style(new Font("Comic Sans MS", 12), blackBrush);
        text.Alignment.Horizontal = Alignment.Center;
        text.AddContent(string.Format(" {0}", e.ExportValue.ToString()), textStyle);

        e.Cancel = true;
    }
}

/// <summary>
/// Sample DataSet.
/// </summary>
public class UltraWebGridSample : DataSet
{
    //Default contructor. Will default to buyer count 50 and order count 0
    public UltraWebGridSample()
    {
        this.ConfigureThis(20, 0);
    }

    //Contsructor, sets buyer count, assumes order count is 0.
    public UltraWebGridSample(uint buyerCount)
    {
        this.ConfigureThis(buyerCount, 0);
    }

    //Constructor, sets buyer and order count.
    public UltraWebGridSample(uint buyerCount, uint orderCount)
    {
        this.ConfigureThis(buyerCount, orderCount);
    }

    //Configures the dataset.
    private void ConfigureThis(uint buyerCount, uint orderCount)
    {
        bool orders;
        if (orderCount > 0) orders = true;

        else orders = false;

        this.CreateSampleSchema(orders);
        this.CreateSampleData(buyerCount, orderCount);
    }

    //Creates the schema for the sample data.
    private void CreateSampleSchema(bool orders)
    {
        DataColumn[] keys = new DataColumn[1];
        this.Tables.Add("Buyers");
        this.Tables[0].Columns.Add("AccountNumber", typeof(int));
        this.Tables[0].Columns.Add("FirstName", typeof(string));
        this.Tables[0].Columns.Add("LastName", typeof(string));
        this.Tables[0].Columns.Add("JoinDate", typeof(DateTime));
        this.Tables[0].Columns.Add("Zip", typeof(string));
        keys[0] = this.Tables[0].Columns["AccountNumber"];
        this.Tables[0].PrimaryKey = keys;
        this.Tables[0].Columns["AccountNumber"].AutoIncrementSeed = 1024;
        this.Tables[0].Columns["AccountNumber"].AutoIncrementStep = 1;
        this.Tables[0].Columns["AccountNumber"].AutoIncrement = true;

        if (orders)
        {
            this.Tables.Add("Orders");
            this.Tables[1].Columns.Add("AccountNumber", typeof(int));
            this.Tables[1].Columns.Add("OrderNumber", typeof(int));
            this.Tables[1].Columns.Add("OrderDate", typeof(DateTime));
            this.Tables[1].Columns.Add("Quantity", typeof(int));
            keys[0] = this.Tables[1].Columns["OrderNumber"];
            this.Tables[1].PrimaryKey = keys;
            this.Tables[1].Columns["OrderNumber"].AutoIncrementSeed = 556;
            this.Tables[1].Columns["OrderNumber"].AutoIncrementStep = 1;
            this.Tables[1].Columns["OrderNumber"].AutoIncrement = true;

            this.Relations.Add("BuyerToOrder", this.Tables[0].Columns[0],
                this.Tables[1].Columns[0], true);
        }
    }

    //Populates the sample data.
    private void CreateSampleData(uint buyerCount, uint orderCount)
    {
        Random rndm = new Random();

        System.Collections.ArrayList accounts = new System.Collections.ArrayList();

        for (int i = 0; i < buyerCount; i++)
        {
            int y = rndm.Next(DateTime.Now.AddYears(-20).Year, DateTime.Now.Year);
            int m = rndm.Next(1, 13);
            int d = rndm.Next(1, DateTime.DaysInMonth(y, m));
            int zip = rndm.Next(1, 99999);
            string zipCode = zip.ToString();

            if (zipCode.Length < 5)
            {
                do
                {
                    zipCode = 0 + zipCode;
                }

                while (zipCode.Length < 5);
            }

            DateTime joinDate = new DateTime(y, m, d);

            string fn = firstNames[rndm.Next(0, firstNames.Length)];
            string ln = lastNames[rndm.Next(0, lastNames.Length)];

            this.Tables["Buyers"].Rows.Add(
                new object[] { null, fn, ln, joinDate, zipCode });

            object[] row = this.Tables["Buyers"].Rows[i].ItemArray;
            accounts.Add(Convert.ToInt32(row[0]));
        }

        if (orderCount > 0)
        {
            for (int i = 0; i < orderCount; i++)
            {
                //Get a random account number that was added to the Buyers table.
                int accountNumber = Convert.ToInt32(accounts[rndm.Next(0, accounts.Count)]);

                //Get the joinDate corresponding to the Buyers account number.                    
                object[] row = (this.Tables[0].Rows.Find(accountNumber)).ItemArray;
                DateTime joinDate = (DateTime)row.GetValue(3);

                //Set an order date.
                DateTime orderDate = new DateTime();
                do
                {
                    int y = rndm.Next(DateTime.Now.AddYears(-20).Year, DateTime.Now.Year);
                    int m = rndm.Next(1, 13);
                    int d = rndm.Next(1, DateTime.DaysInMonth(y, m));

                    orderDate = new DateTime(y, m, d);
                }
                while (orderDate < joinDate);

                //Add the row.
                this.Tables["Orders"].Rows.Add(new object[] { accountNumber, null, orderDate, rndm.Next(1, 100) });
            }
        }
    }

    //Name arrays.
    private string[] firstNames = { "Mary", "Scott", "John", "Jim", "Keith", "Brian",
        "Harry", "Richard", "Robert", "Michael", "Matt", "George", "Don", "Vince",
        "Joe", "Jon", "Yale", "Nick", "Neil", "Bart", "William", "Bill", "Fry",
        "Jason", "Stephanie", "Bree", "Kim", "Kelly", "Lisa", "Joan", "Jennifer" };

    private string[] lastNames = { "Evans", "Harrison", "Smith", "Doe", "Johnson",
        "Griggs", "Harrelson", "Statham", "Williams", "Williamson", "Wells",
        "Cafaro", "Orris", "Dunn", "Taylor", "Lawrence", "Jennings", "Morris",
        "Lincoln", "Ford"};

    //Static helper method to set some basic layout settings.
    public static void SetGridLayout(Infragistics.WebUI.UltraWebGrid.UltraWebGrid ug)
    {
        //JoinDate format
        ug.DisplayLayout.Bands[0].Columns.FromKey("JoinDate").Format = "d";

        //Header captions
        ug.DisplayLayout.Bands[0].Columns.FromKey("AccountNumber").Header.Caption = "Account No.";
        ug.DisplayLayout.Bands[0].Columns.FromKey("FirstName").Header.Caption = "First Name";
        ug.DisplayLayout.Bands[0].Columns.FromKey("LastName").Header.Caption = "Last Name";
        ug.DisplayLayout.Bands[0].Columns.FromKey("JoinDate").Header.Caption = "Joined";
        ug.DisplayLayout.Bands[0].Columns.FromKey("Zip").Header.Caption = "Zip Code";

        //Header captions if the second band exists.
        //Set format and hide accountnumber.
        if (ug.DisplayLayout.Bands.Exists("Orders"))
        {
            ug.DisplayLayout.Bands[1].Columns.FromKey("AccountNumber").Hidden = true;
            ug.DisplayLayout.Bands[1].Columns.FromKey("OrderDate").Format = "d";
            ug.DisplayLayout.Bands[1].Columns.FromKey("OrderNumber").Header.Caption = "Order No.";
            ug.DisplayLayout.Bands[1].Columns.FromKey("OrderDate").Header.Caption = "Order Date";
        }
    }

}
